/*!
 * @file qt_gui.h
 * @brief Definition of ...
*/

#ifndef __QT_GUI_H
#define __QT_GUI_H

#include "../gui.h"
#include "../gui_element.h"
#include <qapplication.h>
#include <qmainwindow.h>

namespace OrxGui
{
  class QtGui : public OrxGui::Gui, QApplication
  {
    public:
      QtGui(int argc, char** argv);
      virtual ~QtGui();

    //! Start the Gui
      virtual void startGui();
    //! Stop the gui
      virtual void stopGui();
    //! Suspend the Gui.
      virtual void suspend();
    //! Update the Gui.
      virtual void update();


    private:
      QMainWindow*              mainWindow;
      std::list<Element*>       elements;       //!< A List of Elements within the QTGui
  };
}

#endif /* __QT_GUI_H */
